/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define SYNCSOURCE_CALENDAR 0
#define SYNCSOURCE_CONTACTS 1
#define SYNCSOURCE_NOTES 2
#define SYNCSOURCE_TASKS 3

#define SCHEDULER_MIN_MINUTES 1
#define SCHEDULER_MAX_MINUTES 1439
#define SCHEDULER_MIN_HOURS 1
#define SCHEDULER_MAX_HOURS 24
#define SCHEDULER_DEFAULT_MINUTES 15

#define SCHEDULER_DEFAULT_MINUTES_WIDE L"15"
#define SCHEDULER_MIN_MINUTES_WIDE L"1"
#define SCHEDULER_MAX_MINUTES_WIDE L"1439"
#define SCHEDULER_MIN_HOURS_WIDE L"1"
#define SCHEDULER_MAX_HOURS_WIDE L"24"

#define SYNC_DEFAULT_TOTAL_ITEMS  20

// Default dimensions of frames (in case of 96dpi)
#define FRAME_CONFIG_X 440
#define FRAME_CONFIG_Y 382
#define FRAME_MAIN_X 350
#define FRAME_MAIN_Y 350

#define MAIN_PROGRESSBAR_COLOR RGB(255,255,255)

#define EDIT_TEXT_MAXLENGTH 255
#define EDIT_TEXT_SCHEDULER_MAXLENGTH 6

#define SYNCTYPE_NONE "none"

//#define LAST_SYNC_TIME_FORMAT TEXT("%A %#d %b %Y %#I:%M%p")
//#define LAST_SYNC_TIME_FORMAT TEXT("%#d %b %Y %#I:%M%p")
#define LAST_SYNC_TIME_FORMAT TEXT("%A, %#I:%M%p")


int getSyncTypeIndex(const char* syncType);

const char* getSyncTypeName    (int index);
const char* getFullSyncTypeName(int index);

int getSyncModeCode(const char* syncMode);

void manageSyncErrorMsg(long code);