/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef INCL_CLIENTMAIL
#define INCL_CLIENTMAIL


#include "outlook/defs.h"
#include "outlook/ClientItem.h"

#include <string>



///////////////////////////////////////////////////////////////////
class ClientMail : public ClientItem {

private:

    // Pointer to microsoft outlook objects.
    _MailItemPtr     pMail;

    // Pointer to Redemption safe objects.
    Redemption::ISafeMailItemPtr pSafeMail;


    void createSafeMailInstance();

    bool isSecureProperty (const std::wstring& propertyName);
    bool isComplexProperty(const std::wstring& propertyName);

    const std::wstring getSafeProperty   (const std::wstring& propertyName);
    const std::wstring getComplexProperty(const std::wstring& propertyName);

    int setComplexProperty(const std::wstring& propertyName, const std::wstring& propertyValue);

public:

    // Constructor
    ClientMail();
    ClientMail(const ClientMail& c);
    ClientMail operator=(const ClientMail& c);

    // Destructor
    ~ClientMail();


    // Set a COM pointer to this object: refresh all members.
    void setCOMPtr(_MailItemPtr& ptr, const std::wstring& itemID);
    void setCOMPtr(_MailItemPtr& ptr);


    //
    // Client operations on the item.
    //
    int saveItem();
    int deleteItem();
    ClientItem* copyItem();


    //
    // Methods to menage item properties.
    //
    //const std::wstring getFirstProperty();
    //const std::wstring getNextProperty();
    //const std::wstring getPreviousProperty();
    //const std::wstring getLastProperty();

    //int setProperty(const std::wstring& propertyName, const std::wstring& propertyValue);

};

#endif
